define(['jquery', 'underscore'], function($, _) {
    var CustomWidget = function () {
    	var self = this;
		this.callbacks = {
			render: function(){
				console.log('render');
				return true;
			},
			destroy: function(){

			},
			init: function(){
				console.log('init');
				return true;
			},
			bind_actions: function(){
				console.log('bind_actions');
				return true;
			},
			onSave: function() {
				return true;
			},
			settings: function () {
				$('.js-widget-save').trigger('button:save:enable');
				return true;
			},

			/**
			 * @description метод, вызов которого происходит при инициализации, должен вернуть массив объектов элементов, которые покажутся при фокусе на поле поиска
			 * @returns {Promise}
			 */
			loadPreloadedData: function () {
				return new Promise(_.bind(function (resolve, reject) {
					self.crm_post(
						'http://my.sdk.api.com/sdk_back/',
						{},
						function (msg) {
							resolve(msg);
						},
						'json'
					);
				}), this);
			},

			/**
			 * @param type - тип сущности, из которой делается запрос
			 * @param id - id сущности из которой делается запрос
			 * @description метод, вызов которого происходит при инициализации, должен вернуть массив объектов элементов, которые привязаны к карточке
			 * @returns {Promise}
			 */
			loadElements: function (type, id) {
				return new Promise(_.bind(function (resolve, reject) {
					self.crm_post(
						'http://my.sdk.api.com/sdk_back/?products=true&type='+type.type+'&entity_id='+id,
						{},
						function (msg) {
							resolve(msg);
						},
						'json'
					);
				}), this);
			},

			/**
			 * @param links - массив данных о привязке или отвязке элементов от сущности
			 * @description метод, вызов которого происходит при сохранении привязки или отвязке сущности от карточки
			 * @returns {Promise}
			 */
			linkCard: function (links) {
				return new Promise(_.bind(function (resolve, reject) {
					self.crm_post(
						'http://my.sdk.api.com/sdk_back/link.php',
						links,
						function () {},
						'json'
					);

					resolve();
				}), this);
			},

			/**
			 * @param query - запрос, который делается на поиск
			 * @param {Number} type - тип сущности, из которой делается запрос
			 * @param {Number} id - id сущности из которой делается запрос
			 * @description метод, вызов которого происходит при поиске карточки
			 * @returns {Promise}
			 */
			searchDataInCard: function (query, type, id) {
				return new Promise(_.bind(function (resolve, reject) {
					self.crm_post(
						'http://my.sdk.api.com/sdk_back/search.php',
						{
							query: query,
							type: type,
							id: id
						},
						function (msg) {
							resolve(msg);
						},
						'json'
					);
				}), this);
			}
		};
		return this;
    };

return CustomWidget;
});